MultiOverlayV2 = {};
MultiOverlayV2.modDir = g_currentModDirectory;
MultiOverlayV2.settingsDir = getUserProfileAppPath().. "moV2Hud_Settings/";
MultiOverlayV2.detiServerDir = getUserProfileAppPath();
MultiOverlayV2.artDesignDir = MultiOverlayV2.settingsDir.. "artDesign/";
MultiOverlayV2.fruitHudDir = MultiOverlayV2.settingsDir.. "fruitHud/";
MultiOverlayV2.gameDir = string.gsub(MultiOverlayV2.modDir, "MultiOverlayV2/", "");
MultiOverlayV2.saveGameDir = "";

MultiOverlayV2.metadata = {
	interface = " FS15 1.3",
	title = " MultiOverlay V2 Hud",
	notes = " Zeigt Aktuelle Preise/Bestände und vieles mehr in einem PDA Hud an",
	author = " (by HappyLooser)",
	version = " v2.1 BETA",
	versionXml = 0.1,
	versionArtDesign = 2,
	datum = " 31.08.2015",
	update = " 21.11.2015",
	web = " http://www.minetropolis.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:  http://fs-uk.com/ (Mike3650)"
};

MultiOverlayV2.timerUpdate = { 
	id = nil;
	delay = 3600000; --1 hours
	updateDay = 0;
	wait = 0;
	first = true;
	interval = 112500; --1.875 min
	palSammler = 900000; --ca. 1/4 hours
	palSammlerTime = 0;
	isUpdate = false;
	isAutoSearch = false;
};
	
function MultiOverlayV2:loadMap(name)		
	print("---loading".. tostring(MultiOverlayV2.metadata.title).. tostring(MultiOverlayV2.metadata.version).. tostring(MultiOverlayV2.metadata.author).. "---")
	if not fileExists(MultiOverlayV2.settingsDir) then createFolder(MultiOverlayV2.settingsDir);end;	
	--local version = string.format("%.1f", Utils.getNoNil(MultiOverlayV2.metadata.versionXml, 0.0));	
	MultiOverlayV2.saveGameDir = MultiOverlayV2.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.. "/"; 
	loadDefaultScripts(true);	
	if AAA_UniversalProcessKit ~= nil and AAA_UniversalProcessKit.UniversalProcessKit ~= nil then 
		moGeneralSettings.upkReady = true;		
	end;
	--MultiOverlayV2.savegameDir = g_currentMission.missionInfo:getSavegameDirectory(g_currentMission.missionInfo.savegameIndex);
	--g_languageShort = "pl";
	MultiOverlayV2.language = "_".. string.lower(g_languageShort);	
	MultiOverlayV2.foundSettings = false;
	MultiOverlayV2.event = {greatDemand_s=false,discount_s=false,greatDemand_c=false,discount_c=false,login=false,isMp=true,isMpUpdate=false};	
	self.greatDemand_s = MultiOverlayV2.event.greatDemand_s;
	self.discount_s = MultiOverlayV2.event.discount_s;
	MultiOverlayV2.loadError = false;
	MultiOverlayV2.loadHostServer = false;
	MultiOverlayV2.loadDetiServer = false;
	MultiOverlayV2.isMp = g_currentMission.missionDynamicInfo.isMultiplayer;
	MultiOverlayV2.isServer = false;	
	if g_server ~= nil then MultiOverlayV2.isServer = true;end;
	MultiOverlayV2.isClient = false;
	if g_client ~= nil then MultiOverlayV2.isClient = true;end;
	if MultiOverlayV2.isMp and MultiOverlayV2.isServer and MultiOverlayV2.isClient and g_dedicatedServerInfo == nil then  MultiOverlayV2.loadHostServer = true;end;
	if MultiOverlayV2.isMp and MultiOverlayV2.isServer and MultiOverlayV2.isClient and g_dedicatedServerInfo ~= nil then  MultiOverlayV2.loadDetiServer = true;end;
	if not MultiOverlayV2.loadDetiServer or MultiOverlayV2.loadHostServer then 
		moLanguageXml:loadTable(self);		
		moObjectXml:load(self);
	end;	
	--MultiOverlayV2.detiServerConnect = g_currentMission.connectedToDedicatedServer;	
	if MultiOverlayV2.loadDetiServer then
		print("!!!! DETISERVER !!!! Disabled" ..tostring(MultiOverlayV2.metadata.title).. " features for DetiServer(not Client)")
		moXmlSettings:load(self, true, false, false, false);
		return;
	end;	
	moXmlSettings:load(self, true, true, true, false);
	loadFirstFillTypesAndStationTriggers(self, false);	
	if MultiOverlayV2.loadError then
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV2.metadata.title).. "has FillTypes Error.... stop Mod")
	else
		if not fileExists(MultiOverlayV2.artDesignDir) then	createFolder(MultiOverlayV2.artDesignDir);end;
		if not fileExists(MultiOverlayV2.fruitHudDir) then	createFolder(MultiOverlayV2.fruitHudDir);end;
		--preLoad
		if moDraw == nil then
			moDraw = {};
		end;
		if moGuiMiniPdaSlots.values ~= nil and moGuiMiniPdaSlots.values[1] ~= nil then
			moGuiMiniPdaSlots.values = {};
		end;
		--preLoad
		g_currentMission.modMultiOverlayUpdate = false;
		loadDefaultScripts(false);		
		loadDraws();
		moSetGetGui:moSetGetGuiLoadTables(self);		
		moXmlSettings:load(self, false, false, false, true);
		searchArtDesign(self);		
		moSetGetGui:loadAllOverlays(self);
		MultiOverlayV2:steerableLoad(self);
		MultiOverlayV2.timerUpdate.id = addTimer(1, "MultiOverlayV2.timerUpdate");		
	end;		
end;

function MultiOverlayV2:deleteMap()	
	if MultiOverlayV2.loadDetiServer then		
		return;
	end;
	saveLsHuds(self);
	if MultiOverlayV2.timerUpdate.id ~= nil then
		removeTimer(MultiOverlayV2.timerUpdate.id)
	end;	
	MultiOverlayV2:saveSettings(self, "clientSettings");
	MultiOverlayV2.timerUpdate.first = true;
	MultiOverlayV2.timerUpdate.updateDay = 0;
	MultiOverlayV2.timerUpdate.wait = 0;
	MultiOverlayV2.timerUpdate.palSammlerTime = 0;
	MultiOverlayV2.timerUpdate.isUpdate = false;
	MultiOverlayV2.timerUpdate.id = nil;
	MultiOverlayV2.loadError = false;
	MultiOverlayV2.loadHostServer = false;
	MultiOverlayV2.loadDetiServer = false;	
	moSetGetGui.deleteAllOverlays(self);
end;

function MultiOverlayV2:mouseEvent(posX, posY, isDown, isUp, button)	
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;	
	moSetGetKeyMouseEvent:setMouse(self, posX, posY, isDown, isUp, button);	
	moSetGetKeyMouseEvent:setKeyMouse(self, nil, nil, nil, nil, posX, posY, isDown, isUp, button)	
end;

function MultiOverlayV2:keyEvent(unicode, sym, modifier, isDown)	
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;
	moSetGetKeyMouseEvent:setKeyMouse(self, unicode, sym, modifier, isDown, nil, nil, nil, nil, nil)		
end;

function MultiOverlayV2:updateTick(dt)	
end;

function MultiOverlayV2:update(dt)	
	if g_server == nil and MultiOverlayV2.event.isMp then		
		MultiOverlayV2.event.isMp = false;
		MultiOverlayV2Event.sendEvent(self.greatDemand_s, self.discount_s, true);
	end;
	if MultiOverlayV2.loadDetiServer or g_currentMission.paused or g_currentMission.ingameMap.isFullSize then		
		return;
	end;
	if moGeneralSettings.setMouseCursor then InputBinding.setShowMouseCursor(true);end;
	if moGeneralSettings.setFrozen then g_currentMission.isPlayerFrozen = true;end;	
	if MultiOverlayV2.timerUpdate.first then		
		MultiOverlayV2.timerUpdate.first = false;
		reloadNewFillTypes(self);
		firstLoadMapObjects(self);
		--firstDisplayZoom(self);						
		MultiOverlayV2.timerUpdate.wait = moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, false)*MultiOverlayV2.timerUpdate.delay;		
		MultiOverlayV2.timerUpdate.updateDay = g_currentMission.environment.currentDay;		
		firstUpdates(self, false);		
		if zzzz_TriggerExtend ~= nil then			
			if zzzz_TriggerExtend.TriggerExtend.setSellMilk then
				moGeneralSettings.triggerExtend = true;			
			end;
		end;
		if ZZZ_courseplay ~= nil then moGeneralSettings.coursePlay = true;end;
		MultiOverlayV2:steerableLoad(self);		
		setFirstLsHuds(self);
		--testFunction(self);		
		return;
	end;	
end;

function MultiOverlayV2:draw()		
	if MultiOverlayV2.loadDetiServer or moSetGetGui.loadImages.refreshAll then		
		return;
	end;
	if g_currentMission.ingameMap.isFullSize == true or g_currentMission.paused then 
		removeViPda(self);
		return true; 
	end;		
	--if moVehicles ~= nil and moVehicles[2].object ~= nil then
	--	local xmlVehicle = string.lower(moVehicles[2].object.configFileName);
	--	local StoreItem = StoreItemsUtil.storeItemsByXMLFilename[xmlVehicle];
	--	local storeImage = createImageOverlay(Utils.getFilename(StoreItem.imageActive));
	--	renderOverlay(storeImage, 0.3, 0.4, 0.05, 0.05);
	--end;
	function setHotSpot()
		if moGuiMiniPdaSlots.isHotSpotObj then				
			moGuiMiniPdaSlots.hotSpotEnd = moGuiMiniPdaSlots.hotSpotEnd-1
			if moGuiMiniPdaSlots.hotSpotEnd <= 5 or moGuiMiniPdaSlots.hotSpotSlot ~= moGuiMiniPdaSlots.keySwitchLast then moGuiMiniPdaSlots.isHotSpotObj = false;moGuiMiniPdaSlots.hotSpotEnd = 500;moSetGetGui:setGetHotSpotMap(self, false, false);end;				
		end;
	end;
	if moGuiMiniPdaSlots.isActive then	
		if moGuiMiniPdaSlots.activeTotal ~= 0 and moSetGetGui.loadImages.slots and not moGuiMiniPdaSlots.isHiden then				
			for a=1, moGuiMiniPdaSlots.activeTotal do
				moSetGetGui["slot".. a]:render();
				moSetGetGui["keySwitch"]:render();
				setSlotNotReadyFoundObjects(self, a);				
				if moGuiMiniPdaSlots.values[a].isOpen and not moSetGetGui.cfgMenue.all and not moSetGetGui.isActivePage then
					setOpenMiniPdaSlot(self, a);
				end;				
			end;
			setSlotWarningMiniPda(self);
			setHotSpot();
			if moGuiMiniPdaSlots.isSeeSmallDraw then
				moGuiMiniPdaSlots.seeSmallDrawEnd = moGuiMiniPdaSlots.seeSmallDrawEnd-1
				moDraw["seeSmall"]:setOpenSlot(self);
				if moGuiMiniPdaSlots.seeSmallDrawEnd <= 5 then moGuiExtras:disableExtraDraws(self, true, false);end;
			end;
			if moGuiMiniPdaSlots.fieldsInfo.isExtraDraw then				
				moDraw["extraFields"]:setOpenField(self);
				if moGuiMiniPdaSlots.fieldsInfo.autoCloseExtraDraw then
					moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd = moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd-1
					if moGuiMiniPdaSlots.fieldsInfo.extraDrawEnd <= 5 then moGuiExtras:disableExtraDraws(self, false, true);end;
				end;				
			end;
			if moGuiMiniPdaSlots.isFieldBuyTrigger then
				moGuiMiniPdaSlots.fieldBuyEnd = moGuiMiniPdaSlots.fieldBuyEnd-1
				if moGuiMiniPdaSlots.fieldBuyEnd <=5 then moGuiMiniPdaSlots.isFieldBuyTrigger = false;end;
			end;
		end;
	end;
	if moSetGetGui.isActivePage and moSetGetGui.loadImages.pages and not moSetGetGui.cfgMenue.all then
		moDraw["pageMenue"]:setOpen(self);
		setOpenPage(self);
		setHotSpot();
	end;
	if moSetGetGui.cfgMenue.all and moSetGetGui.loadImages.cfgMenues then
		moDraw["cfgMenue"]:setOpen(self, nil);		
	end;
	if moSetGetGui.dragDropPos then				
		moSetGetGui["newPosRahmen"]:render();		
	end;
	if moSetGetGui.pdaVI.on then
		if not moSetGetGui.pdaVI.isHiden and not moSetGetGui.pdaVI.cfg or (moSetGetGui.pdaVI.cfg and moSetGetGui.pdaVI.cfgHiden) then
			MultiOverlayV2:setOpenViPDA(self);
		end;
	end;
	if moGeneralSettings.testNumber ~= 0 then
		renderText(0.3, 0.22, 0.012, tostring(moGeneralSettings.testNumber));
	end;
	if string.len(moGeneralSettings.testString) > 0 then
		renderText(0.3, 0.2, 0.012, tostring(moGeneralSettings.testString));
	end;	
	--moSetGetGui["viCfg"]:render();moSetGetGui["seeds"]:setPosition(0.3, 0.2);
	--moSetGetGui["seeds"]:render();
	--moSetGetGui["okay"]:render();
	--respect settings for other mods
	setTextAlignment(false);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(MultiOverlayV2);

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function setOpenMiniPdaSlot(self, slot)	
	local drawName = moGuiMiniPdaSlots.values[slot].name;	
	if moDraw[drawName] ~= nil then			
		moDraw[drawName]:setOpenPdaSlot(self, slot, drawName);
		if moGuiMiniPdaSlots.values[slot].settings then
			moDraw["cfgMenue"]:setOpen(self, slot);
		end;
	else
		if tostring(drawName) == "silagesilos" and moDraw["bga"] ~= nil then	
			moDraw["bga"]:setOpenPdaSlot(self, slot, drawName);
			if moGuiMiniPdaSlots.isSlotCfg and moGuiMiniPdaSlots.values[slot].settings then
				moDraw["cfgMenue"]:setOpen(self, slot);
			end;
			return;
		else
			if moDraw["slots"] ~= nil then
				moDraw["slots"]:setOpenPdaSlot(self, slot, drawName);
				if moGuiMiniPdaSlots.isSlotCfg and moGuiMiniPdaSlots.values[slot].settings then
					moDraw["cfgMenue"]:setOpen(self, slot);
				end;
				return;
			end;			
		end;
		moGuiExtras:closeOpenSlot(self, slot, true, false);				
		g_currentMission:showBlinkingWarning("not found moDraw.".. tostring(drawName).. ".lua (if error !!)", 2000);		
	end;	
end;

function setSlotNotReadyFoundObjects(self, slot)
	if moGuiMiniPdaSlots.values[slot].foundObjects == 0 then
		moSetGetGui["notReadySlot"]:setPosition(moGuiMiniPdaSlots.values[slot].posX, moGuiMiniPdaSlots.values[slot].posY);
		moSetGetGui["notReadySlot"]:render();
	end;
end;

function setOpenPage(self)	
	if moSetGetGui.activePage == 1 and not moSetGetGui.page[1].isHiden then
		moDrawPage1:setOpenPage(self);
	elseif moSetGetGui.activePage == 2 then 
		if not moSetGetGui.page[2].isHiden then
			moDrawPage2:setOpenPage(self);
		end;
		if moSetGetGui.page[2].switch == 3 and moSetGetGui.page[2].mboBuyShowGui then
			if moSetGetGui.page[2].mboBuyShowTimer > moSetGetGui.page[2].mboBuyShowTimerMax then		
				moGuiExtras:disableMboBuyShowGui(self);				
			else
				moSetGetGui.page[2].mboBuyShowTimer = moSetGetGui.page[2].mboBuyShowTimer+1;
			end;
		end;
	elseif moSetGetGui.activePage == 3 and not moSetGetGui.page[3].isHiden then
		moDrawPage3:setOpenPage(self);
	end;	
end;

function setSlotWarningMiniPda(self)	
	if moSetGetGui.loadImages.warnings then --and moGuiMiniPdaSlots.values[slot].isWarning == 2 and moGuiMiniPdaSlots.values[slot].foundObjects > 0 then							
		moDrawWarnings:setGet(self);		
	end;	
end;

function setStationUpdate(self, all)	
	moSetGetStationes:setStationUpdate(self, all);
end;

function setDemandSalesUpdate(self)	
	if MultiOverlayV2.isMp or MultiOverlayV2.loadHostServer then
		if MultiOverlayV2.event.greatDemand_s and MultiOverlayV2.event.greatDemand_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, true, false);
		end;
		if MultiOverlayV2.event.discount_s and MultiOverlayV2.event.discount_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, false, true);
		end;
	else
		if MultiOverlayV2.event.greatDemand_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, true, false);
		end;
		if MultiOverlayV2.event.discount_c then
			moSetGetDemandSales:setDemandSalesUpdate(self, false, true);
		end;
	end;	
end;

function MultiOverlayV2:setSlotUpdate(self, slot, first)
	if first == nil and not moGuiMiniPdaSlots.values[slot].isOpen then return;end;
	local slotName = MultiOverlayV2:getSlotName(slot);	
	if first then 
		if slotName == "amount" then moGuiMiniPdaSlots.values[slot].foundObjects = moGeneralSettings.Fillable_NUM_FILLTYPES;return;end;
		if slotName == "bestprice" then moGuiMiniPdaSlots.values[slot].foundObjects = 3;return;end;		
	end;
	if slotName == "amount" or slotName == "bestprice" or slotName == "shop1" or slotName == "shop2" then return;end;
	if slotName == "bga" or slotName == "silagesilos" then moSetGetBga:setBgaUpdate(self, slot, slotName);return;end;
	if slotName == "fieldsprice" or slotName == "fieldsinfo" then moSetGetFields:setFieldsPriceUpdate(self, slot, slotName);return;end;
	moSetGetSlotObjects:setUpdate(self, slot, slotName);
end;

function MultiOverlayV2:mouseIsInArea(mouseX, mouseY, areaX1, areaX2, areaY1, areaY2)
	return mouseX >= areaX1 and mouseX <= areaX2 and mouseY >= areaY1 and mouseY <= areaY2;
end;

function MultiOverlayV2:getSlot(slotName)
	local slotActiveName = Utils.splitString(" ", moGuiMiniPdaSlots.activeName);
	local slot = 0;			
	for a=1, table.getn(slotActiveName) do
		if slotActiveName[a] == slotName then 
			slot = a;					
			break;
		end;
	end;
	return slot;
end;

function MultiOverlayV2:getSlotName(slot)
	--local slotActiveName = Utils.splitString(" ", moGuiMiniPdaSlots.activeName);
	local slotName = "";			
	--for a=1, table.getn(slotActiveName) do
	--	if a == slot then 
	--		slotName = slotActiveName[a];					
	--		break;
	--	end;
	--end;
	if moGuiMiniPdaSlots.values[slot].name ~= nil then slotName = moGuiMiniPdaSlots.values[slot].name;end;
	return slotName;
end;

function loadFirstFillTypesAndStationTriggers(self)
	moSetGetFillTypes:setFirstFillTypes(self);
	moSetGetStationes:setFirstStationTriggers(self);
end;

function firstLoadMapObjects(self)
	moSetGetMapObjects:searchFirstMapObjects(self);
end;

function reloadNewFillTypes(self)
	if moGeneralSettings.Fillable_NUM_FILLTYPES ~= Fillable.NUM_FILLTYPES then
		moSetGetFillTypes:setFirstFillTypes(self, true);
	end;
	if moSetGetGui.vsHud.newFruitHuds then moGuiExtras:newFruitHudsLoad(self);end;
	moSetGetFillTypes:setFirstFruitTypes(self);
end;

function firstUpdates(self, isActive)
	if not isActive then
		setStationUpdate(self, true);
		moSetGetBga:setFirstBgaUpdate(self);		
		setDemandSalesUpdate(self);
		moSetGetFields:setFieldsDefination(self);
		moSetGetFields:setFieldsAndFruitsValues(self)
		if not moGeneralSettings.multiFarm and moGeneralSettings.multiFarmSilo > 0 or moGeneralSettings.multiFarm and moGeneralSettings.multiFarmFound == 0 then moGeneralSettings.multiFarmSilo = 0;moGeneralSettings.multiFarm = false;end;
	end;
	if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.activeTotal > 0 then
		for a=1, moGuiMiniPdaSlots.activeTotal do
			MultiOverlayV2:setSlotUpdate(self, a, true);
		end;
	end;	
end;

function timerUpdate(self)	
	if MultiOverlayV2.timerUpdate.id == nil then return;end;
	if not MultiOverlayV2.timerUpdate.isUpdate and g_currentMission ~= nil then
		MultiOverlayV2.timerUpdate.isUpdate = true;
		local currentTime = g_currentMission.environment.dayTime;		
		if MultiOverlayV2.timerUpdate.updateDay ~= g_currentMission.environment.currentDay then
			MultiOverlayV2.timerUpdate.updateDay = g_currentMission.environment.currentDay;			
			if moGeneralSettings.palSammler or moGeneralSettings.wollPalCollector then
				if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer then
					MultiOverlayV2.timerUpdate.palSammlerTime = currentTime+MultiOverlayV2.timerUpdate.palSammler;				
					moGuiExtras:updateFillablePallet(self);				
				end;
			end;
			MultiOverlayV2:saveSettings(self, "clientSettings"); --hours save			
			setStationUpdate(self, true);			
		else			
			if moGeneralSettings.palSammler or moGeneralSettings.wollPalCollector then
				if MultiOverlayV2.isMp and not MultiOverlayV2.loadHostServer then
					if MultiOverlayV2.timerUpdate.palSammlerTime <= currentTime then
						MultiOverlayV2.timerUpdate.palSammlerTime = currentTime+MultiOverlayV2.timerUpdate.palSammler;					
						moGuiExtras:updateFillablePallet(self);								
					end;
				end;
			end;
			setStationUpdate(self, false);			
		end;
		setDemandSalesUpdate(self);		
		if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.activeTotal > 0 and not MultiOverlayV2.timerUpdate.first and not moGuiMiniPdaSlots.isHiden then
			for a=1, moGuiMiniPdaSlots.activeTotal do
				if not moGuiMiniPdaSlots.values[a].permUpdate then
					MultiOverlayV2:setSlotUpdate(self, a);
				end;
			end;
		end;
		MultiOverlayV2.timerUpdate.isUpdate = false;
		setTimerTime(MultiOverlayV2.timerUpdate.id, MultiOverlayV2.timerUpdate.interval);		
		return true;	
	end;
end;

function MultiOverlayV2:saveSettings(self, settingsFile)
	if settingsFile == "clientSettings" then moSetGetConfigXml:saveConfig(self);end;
end;

function setFirstLsHuds(self)
	moSetGetGui.wtmHud.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2WtmHud, false));
	moSetGetGui.vsHud.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2VsHud, false));
	moSetGetGui.miniMap.binding = Utils.getNoNil(getKeyIdOfModifier(InputBinding.MoV2MiniMap, false));
	if moSetGetGui.wtmHud.binding and not moSetGetGui.wtmHud.on then moGuiExtras:setGetWtmHud(self, false);end;
	if not moSetGetGui.helpText then moGuiExtras:setGetHelpText(self, false);end;
	if moSetGetGui.miniMap.binding and not moSetGetGui.miniMap then moGuiExtras:setGetMiniMap(self, false);end;
	if moSetGetGui.vsHud.binding and not moSetGetGui.vsHud then moGuiExtras:setGetVsHud(self, false);end;
	if moSetGetGui.vsHud.fruitNamesOn or moSetGetGui.vsHud.fillPriceOn then moGuiExtras:fruitNamesOnLoad(self);end;
end;

function saveLsHuds(self)	
	--if moSetGetGui.closeAllHud then 
	--moGuiExtras:setGetCloseAllHud(self, 0, true);
	--end;
	if moGuiMiniPdaSlots.isActive and moGuiMiniPdaSlots.values ~= nil and moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast] ~= nil then
		if moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast].isOpen and moGuiMiniPdaSlots.values[moGuiMiniPdaSlots.keySwitchLast].closeAllHud then
			moGuiExtras:setGetCloseAllHud(self, moGuiMiniPdaSlots.keySwitchLast, true);
		end;
	end;
	if not g_currentMission.showHelpText then 
		moSetGetGui.helpText = false;
	else
		moSetGetGui.helpText = true;
	end;
	if moSetGetGui.miniMap.binding and not g_currentMission.ingameMap.isVisible then
		moSetGetGui.miniMap.on = false;
	else
		moSetGetGui.miniMap.on = true;
	end;
	if moSetGetGui.wtmHud.binding and not g_currentMission.showWeatherForecast then
		moSetGetGui.wtmHud.on = false;
	else
		moSetGetGui.wtmHud.on = true;
	end;
	if moSetGetGui.vsHud.binding and not g_currentMission.showVehicleSchema then
		moSetGetGui.vsHud.on = false;
	else
		moSetGetGui.vsHud.on = true;
	end;
end;

function loadSettings(self, settingsFile)
	
end;

function MultiOverlayV2:setOpenViPDA(self)
	if moSetGetGui.pdaVI.autoPos == 0 then
		if g_currentMission.showHelpText and g_currentMission.hudHelpContentOverlay.y ~= 0 then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.hudHelpContentOverlay.y;
			if g_currentMission.hudHelpTextLineSpacing ~= 0 then moSetGetGui.pdaVI.posY = moSetGetGui.pdaVI.posY - g_currentMission.hudHelpTextLineSpacing*2;end;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = 0.994;			
		end;
	elseif moSetGetGui.pdaVI.autoPos == 1 then
		if g_currentMission.ingameMap.isVisible then
			if moSetGetGui.pdaVI.hideSwitch == 2 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = g_currentMission.ingameMap.minMapHeight + 0.02;
		else
			if moSetGetGui.pdaVI.hideSwitch == 1 then removeViPda(self);return;end;
			moSetGetGui.pdaVI.posY = 0.002;			
		end;
	end;
	if moSetGetGui.pdaVI.iconDesign and not moSetGetGui.loadImages.vi then
		g_currentMission:showBlinkingWarning("not found VI Icons".. tostring("(set TextDesign)"), 2000);
		moSetGetGui.pdaVI.distanceLine = false;
		moSetGetGui.pdaVI.iconDesign = false;
	end;
	if moDraw.vehicles ~= nil then moDraw.vehicles:setOpenPDA(self);end;	
end;

function removeViPda(self)
	if moVehicles ~= nil then table.remove(moVehicles);end;	
end;

function searchArtDesign(self)	
	moSetGetArtDesign:searchArtDesign(self);
end;

function MultiOverlayV2:steerableLoad(self)
	local name = {"vehicle.name.".. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle#type"};
	if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) orgSteerableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknown") 
			end; 
		end; 
	end; 
	if Attachable.load ~= nil then 
		local orgAttachableLoad = Attachable.load 
		Attachable.load = function(self,xmlFile) orgAttachableLoad(self,xmlFile) 
			for key,XMLPath in pairs(name) do 
				self.name = getXMLString(xmlFile, XMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("Unknown") 
			end; 
		end; 
	end; 
end;

function getKeyIdOfModifier(binding)
    local bindingFound = nil;
	for key, value in pairs(InputBinding.actions[binding]) do		
		if key == "keys1" or key == "keys2" or key == "mouseButtons" or key == "gamepadButtons" then
			bindingFound = value[1];
			if bindingFound ~= nil then break;end;
		end;
	end;
    return bindingFound;
end

---coursePlay onFoot
function MultiOverlayV2.drawMouseButtonHelp(self, posY, txt)
	local xLeft = g_currentMission.hudHelpTextPosX1;
	local xRight = g_currentMission.hudHelpTextPosX2;

	local ovl = moSetGetGui["mouse6"]
	if ovl then
		local y = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*3;
		ovl:setPosition(xLeft - ovl.width*0.2, y);
		ovl:render();
		--xLeft = xLeft + ovl.width*0.6;
	end;

	posY = posY - g_currentMission.hudHelpTextSize - g_currentMission.hudHelpTextLineSpacing*2;
	setTextAlignment(RenderText.ALIGN_RIGHT);
	renderText(xRight, posY, g_currentMission.hudHelpTextSize, txt);

	--setTextAlignment(RenderText.ALIGN_LEFT);
	--renderText(xLeft, posY, g_currentMission.hudHelpTextSize, "Click");
end;
--coursePlay onFoot

function loadDraws()
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawCfgMenue.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawPageMenue.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawVehicles.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawBga.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawFieldsPrice.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawAmount.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawBestPrice.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawWarnings.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawSlots.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawSeeSmall.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawFieldsInfo.lua");
	source(MultiOverlayV2.modDir.."scripte/draw/moDrawExtraFields.lua");
end;

function loadDefaultScripts(first)
	if first then
		source(MultiOverlayV2.modDir.."defaultSettings/moLoadTables.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moLanguageXml.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moObjectXml.lua");		
		source(MultiOverlayV2.modDir.."defaultSettings/moXmlSettings.lua");	
		source(MultiOverlayV2.modDir.."defaultSettings/moSetGetConfigXml.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetFillTypes.lua");		
		source(MultiOverlayV2.modDir.."scripte/moSetGetStationes.lua");		
	else
		source(MultiOverlayV2.modDir.."scripte/moGuiExtras.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetMapObjects.lua");		
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moMouseClickAreas.lua");
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moSetGetKeyMouseEvent.lua");
		source(MultiOverlayV2.modDir.."scripte/mouseKeyEvents/moDragDrop.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetVehicles.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetArtDesign.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetGui.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetAmount.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetDemandSales.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetBga.lua");
		source(MultiOverlayV2.modDir.."scripte/moSetGetFields.lua");	
		source(MultiOverlayV2.modDir.."scripte/moSetGetSlotObjects.lua");
	end;
end;


function testFunction(self)
	--g_i18n:formatNumber(capacity)
	--g_currentMission:addWarning(g_i18n:getText(FruitUtil.fruitIndexToDesc[fruitType].name) .. g_i18n:getText("notAcceptedHere"), 0.018, 0.033);
	--currentPalletFillPercentage    --woolpallet check laut gigant :-(
	--numObjectsInPalletSpawnerTrigger, sheep !	
	print("testFunction..............")	
	-------------------------
	
	--noch schreiben	
end;

function MultiOverlayV2:debug(file, txt)
	print("Debug MultiOverlayV2 Hud.......begin...")
	print(tostring(MultiOverlayV2:tableToString(moGuiMiniPdaSlots.values)));	
	print("moddir ".. tostring(MultiOverlayV2.modDir))
	print("settingsdir ".. tostring(MultiOverlayV2.settingsDir))
	print("gamedir ".. tostring(MultiOverlayV2.gameDir))
	print("savegamedir ".. tostring(MultiOverlayV2.savegameDir))
	print("language ".. tostring(MultiOverlayV2.language))
	print("loaderror ".. tostring(MultiOverlayV2.loadError))
	print("loadHostMp ".. tostring(MultiOverlayV2.loadHostMp))
	print("isMp ".. tostring(MultiOverlayV2.isMp))
	print("isServer ".. tostring(MultiOverlayV2.isServer))
	print("isClient ".. tostring(MultiOverlayV2.isClient))		
	print("Debug MultiOverlayV2 Hud.......end.....")
end;

function MultiOverlayV2:tableToString(tt, indent, done)
	--print(tostring(MultiOverlayV2:tableToString(...)));
	--for key, value in pairs(.....) do
	--	print("key und value ...".. tostring(key).. "-----".. tostring(value))
	--end;	
	done = done or {}
	indent = indent or 0
	if type(tt) == "table" then
		local sb = {}
		for key, value in pairs (tt) do
			table.insert(sb, string.rep (" ", indent))
			if type (value) == "table" and not done [value] then
				done [value] = true
				table.insert(sb, "{\n");
				table.insert(sb, MultiOverlayV2:tableToString (value, indent + 2, done))
				table.insert(sb, string.rep (" ", indent))
				table.insert(sb, "}\n");
			elseif "number" == type(key) then
				table.insert(sb, string.format("\"%s\"\n", tostring(value)))
			else
				table.insert(sb, string.format("%s = \"%s\"\n", tostring(key), tostring(value)))
			end
		end
		return table.concat(sb)
	else
		if tt == nil then return "table error.........";end;
		return tt .. "\n"
	end
end

-----------------------------
MultiOverlayV2Event = {};
MultiOverlayV2Event_mt = Class(MultiOverlayV2Event, Event);
InitEventClass(MultiOverlayV2Event, "MultiOverlayV2Event");

function MultiOverlayV2Event:emptyNew()    
	local self = Event:new(MultiOverlayV2Event_mt );
    self.className="MultiOverlayV2Event";
    return self;
end;

function MultiOverlayV2Event:new(greatDemandNew, discountNew, noEventSend)    	
	local self = MultiOverlayV2Event:emptyNew();
	self.greatDemand_s = greatDemandNew;
	self.discount_s = discountNew;
	MultiOverlayV2.event.login = noEventSend;	
    return self;
end;

function MultiOverlayV2Event:readStream(streamId, connection)    
	self.greatDemand_s = streamReadBool(streamId); 
	self.discount_s = streamReadBool(streamId);
    MultiOverlayV2.event.login = streamReadBool(streamId);	
	self:run(connection);
end;

function MultiOverlayV2Event:writeStream(streamId, connection)    	
	streamWriteBool(streamId, self.greatDemand_s);
	streamWriteBool(streamId, self.discount_s);
	streamWriteBool(streamId, MultiOverlayV2.event.login); 
end;

function MultiOverlayV2Event:run(connection)
	if self.greatDemand_s ~= nil and not MultiOverlayV2.event.login and not MultiOverlayV2.event.isMpUpdate then		
		self.greatDemand_s = self.greatDemand_s;
		self.discount_s = self.discount_s;
		self:setGreatDemandDiscountEvent(self.greatDemand_s, self.discount_s, true);		
	end;
	if MultiOverlayV2.event.login and not MultiOverlayV2.event.isMpUpdate then		
		self.greatDemand_s = MultiOverlayV2.event.greatDemand_s;
		self.discount_s = MultiOverlayV2.event.discount_s;
		MultiOverlayV2Event.sendEvent(self.greatDemand_s, self.discount_s, false)	
	end;
end;

function MultiOverlayV2Event.sendEvent(greatDemandNew, discountNew, noEventSend)		
	if g_server ~= nil and g_server ~= false and not noEventSend then		
		g_server:broadcastEvent(MultiOverlayV2Event:new(greatDemandNew, discountNew, false), nil, nil, nil);		
	end;
	if g_server == nil and noEventSend then		
		g_client:getServerConnection():sendEvent(MultiOverlayV2Event:new(greatDemandNew, discountNew, true));
	end;
end;

function MultiOverlayV2Event:setGreatDemandDiscountEvent(greatDemandNew, discountNew, noEventSend)	
	if greatDemandNew ~= nil and discountNew ~= nil then		
		MultiOverlayV2.event.greatDemand_s = greatDemandNew;
		MultiOverlayV2.event.discount_s = discountNew;
		MultiOverlayV2.event.isMpUpdate = true;						
	end;
end;
---------------
